///////////////////////////////////////////////////////////////////////////////////////////
// MAT 259 - Assignment 1 Revision
// by Nataly Moreno
///////////////////////////////////////////////////////////////////////////////////////////


int [][] dataMatrix = null;
int numRows = 15;           //7 books and 8 movies
int numColumns = 108;       //2004-2013: 9 years * 12 months

//Fun Fonts for me :D
PFont funFont1 = createFont("Courier", 14, true);
PFont funFont2 = createFont("Chalkboard", 24, true);
PFont funFont3 = createFont("Apple Chancery", 24, true);

//Other Fonts
PFont font1    = createFont("Arial", 12, true);     
PFont font2    = createFont("Helvetica", 18, true); 

Table myTable;
int maxCheckOuts = -1;

int cellWidth  = 9;
int cellHeight = 18;
int rowMargin  = 100;
int colMargin  = 100;

int barPosX   = 675;
int barPosY   = 450;
int barLength = 400;
int barHeight = 30;
int barColor  = -1;

int colorTheme = 1;
int colorMode[]         = {HSB, HSB, HSB, HSB, HSB, HSB};

color backgroundColor[] = {color(0),
                           color(0),
                           color(0),
                           color(0),
                           color(114, 114, 114, 100),
                           color(0)
                          };
                          
color cellBackground[]  = {color(128),
                           color(128),
                           color(128),
                           color(128),
                           color(128),
                           color(128)
                          };
  
color cellOutline[]     = {color(255, 153, 255, 100),  //scheme 0
                           color(180, 153, 255, 100),  //scheme 1
                           color(180, 150, 255, 100),  //scheme 2 
                           color(180, 150, 255, 100),
                           color(180, 150, 255, 100),
                           color(180, 150, 255, 100)
                          };
                           
color dataCells[]       = {color(180, 155, 255),       //scheme 0
                           color(180, 150, 255, 100),  //scheme 1
                           color(255, 150, 50),        //scheme 2
                           color(255, 150, 50),
                           color(170),
                           color(178, 255, 102)
                          };

color lineSeparator[]   = {color(30, 144, 255, 100),   //scheme 0
                           color(100, 255, 100, 100),  //scheme 1
                           color(255, 150, 50, 100),   //scheme 2
                           color(255, 150, 50, 100),
                           color(255, 150, 50, 100),
                           color(255, 235, 0, 100)
                          };
                           
color colorBarOutline[] = {color(30, 144, 255,200),    //scheme 0
                           color(180, 155, 255, 100),  //scheme 1
                           color(255, 150, 50, 100),   //scheme 2
                           color(255, 150, 50, 100),
                           color(255, 150, 50, 100),
                           color(255, 150, 50, 100)
                          };
                           
color colorLabel[]      = {color(30, 144, 255),        //scheme 0
                           color(100, 255, 100, 100),  //scheme 1
                           color(255, 150, 50),        //scheme 2
                           color(255, 150, 50),
                           color(0),
                           color(255, 220, 0)
                          };
                           
color outlineBorder[]   = {color(30, 144, 255, 130),   //scheme 0
                           color(200, 255, 100, 100),  //scheme 1
                           color(255, 150, 50, 130),   //scheme 2
                           color(255, 150, 50, 130),
                           color(0),
                           color(255, 255, 0, 130)
                          };
                           
int barDiv[] = {100, 100, 100, 100, 100, 100};


///////////////////////////////////////////////////////////////////////////////////////////
// Helper Functions
///////////////////////////////////////////////////////////////////////////////////////////

void printDataMatrix()
{
    for(int i = 0; i < numRows; i++)
  {
    for(int j = 0; j < numColumns; j++)
    {
      print(dataMatrix[i][j] + " ");
    }
    println("\n");
  }
}

void cellColor(int i, int j)
{
  switch(colorTheme)
  {
    case 0:
      fill(red(dataCells[colorTheme]), green(dataCells[colorTheme]), dataMatrix[j][i]);
      break;
    case 1:
      if(dataMatrix[j][i] != 0)
      {
        fill(  red(dataCells[colorTheme]) * dataMatrix[j][i] / maxCheckOuts, 
             green(dataCells[colorTheme]),
              blue(dataCells[colorTheme]) * dataMatrix[j][i] / maxCheckOuts);
      }
      else
      {
        fill(0, 0, 0);
      }
      break;
    case 2:
      if(dataMatrix[j][i] != 0)
      {
        fill(       hue(dataCells[colorTheme]) * dataMatrix[j][i] / maxCheckOuts, 
             saturation(dataCells[colorTheme]),
             brightness(dataCells[colorTheme]) * dataMatrix[j][i] / maxCheckOuts);
      }
      else
      {
        fill(0, 0, 0);
      }
      break;
    case 3:
      if(dataMatrix[j][i] != 0)
      {
        fill(  red(dataCells[colorTheme]) * dataMatrix[j][i] / maxCheckOuts, 
             green(dataCells[colorTheme]),
              blue(dataCells[colorTheme]) * 4);
      }
      else
        fill(0);
      break;
    case 4:
      if(dataMatrix[j][i] != 0)
      {
        fill(red(dataCells[colorTheme]) * dataMatrix[j][i] / maxCheckOuts);
      }
      else
        fill(0);
      break;
    case 5:
      if((j < 13) && (j % 2 == 0))
      {
        if(dataMatrix[j][i] != 0)
        {
          fill(       hue(dataCells[colorTheme]) - 30, 
               saturation(dataCells[colorTheme]) + 70,
               brightness(dataCells[colorTheme]) * dataMatrix[j][i] / maxCheckOuts);
        }
        else
          fill(0);
      }
      else
      {
        if(dataMatrix[j][i] != 0)
        {
          fill(       hue(dataCells[colorTheme]), 
               saturation(dataCells[colorTheme]) + 30,
               brightness(dataCells[colorTheme]) * dataMatrix[j][i] / maxCheckOuts);
        }
        else
          fill(0);
      }
      break;
    default:
      break;
  }
}

void colorBarFill(int i)
{
  switch(colorTheme)
  {
    case 0:
      fill( red(dataCells[colorTheme]), green(dataCells[colorTheme]), 
           blue(dataCells[colorTheme]) * i / barDiv[colorTheme]);
      break;
    case 1:
      fill(  red(dataCells[colorTheme]) * i / barDiv[colorTheme], 
           green(dataCells[colorTheme]),
            blue(dataCells[colorTheme]) * i / barDiv[colorTheme]);
      break;
    case 2:
      fill(       hue(dataCells[colorTheme]) * i / barDiv[colorTheme], 
           saturation(dataCells[colorTheme]),
           brightness(dataCells[colorTheme]) * i / barDiv[colorTheme]);
      break;
    case 3:
      fill(  red(dataCells[colorTheme]) * i / barDiv[colorTheme], 
           green(dataCells[colorTheme]),
           blue(dataCells[colorTheme]) * 4);
      break;
    case 4:
      fill(  red(dataCells[colorTheme]) * i / barDiv[colorTheme]);
      break;
    case 5:
      if(barColor == 0) //it's a book
      {
        fill(       hue(dataCells[colorTheme]) - 30, 
             saturation(dataCells[colorTheme]) + 70,
             brightness(dataCells[colorTheme]) * i / barDiv[colorTheme]);
      }
      else // it's a film
      {
        fill(       hue(dataCells[colorTheme]), 
             saturation(dataCells[colorTheme]) + 30,
             brightness(dataCells[colorTheme]) * i / barDiv[colorTheme]);
      }
      break;
    default:
      break;
  }
}

///////////////////////////////////////////////////////////////////////////////////////////
// Program's Basic Functions
///////////////////////////////////////////////////////////////////////////////////////////

void setup()
{
  size(1190, 560);
  background(255);
  smooth();
  println("SetUp Done!");
  myTable = loadTable("XcelCombined.csv", "header");
  
  println("Rows: " + myTable.getColumnCount());
  println("Columns: " + myTable.getRowCount());
  
  dataMatrix = new int[numRows][numColumns];
  
  int k = 0; //row
  int m = 0; //column
  
  for(int i = 0; i < myTable.getRowCount(); i++)
  {
    for(int j = 2; j < myTable.getColumnCount(); j++)
    {   
      maxCheckOuts = max(myTable.getInt(i,j), maxCheckOuts);   
      dataMatrix[k][m] = myTable.getInt(i,j);
      k++;
      
      if(k == 15)
      {
        k = 0;
        m++;
      }
    }
  }
}

void draw()
{
  colorMode(RGB);
  background(255);
  
   //Background Over-Color
  fill(backgroundColor[colorTheme]);
  rect(0, 0, width, height);

  //Background for Cells
  fill(cellBackground[colorTheme]);
  rect(rowMargin, colMargin, cellWidth * numColumns, cellHeight * numRows);
  
  
  //Data Cells
  for(int i = 0, k = 0; i < numColumns; i++, k++)
  {
    for(int j = 0; j < numRows; j++)
    {
      colorMode(RGB);
      stroke(cellOutline[colorTheme]);
      strokeWeight(0.014);
      
      colorMode(colorMode[colorTheme]);
      cellColor(i,j);      
      colorMode(RGB);
      rect(rowMargin + k * cellWidth, colMargin + j * cellHeight, cellWidth, cellHeight);
    }
  }

  //Line Annual Separators
  stroke(lineSeparator[colorTheme]);
  fill(colorLabel[colorTheme]);
  for(int i = 0, k = 0; i < numColumns; i++, k++)
  {
    strokeWeight(1);
    
    if(k == 0)
      line(rowMargin + (k * cellWidth), 
      colMargin + numRows * cellHeight, 
      rowMargin + (k * cellWidth), 
      colMargin + numRows * cellHeight + 15);
      
    if((k + 1) % 12 == 0)
      line(rowMargin + ( (k + 1) * cellWidth), 
      colMargin + numRows * cellHeight, 
      rowMargin + ( (k + 1) * cellWidth), 
      colMargin + numRows * cellHeight + 15);
  }
  
  //Row Labels
  String[] labels = {"Book 1", "Film 1", "Book 2", "Film 2", "Book 3", "Film 3",
                     "Book 4", "Film 4", "Book 5", "Film 5", "Book 6", "Film 6",
                     "Book 7", "Film 7", "Film 8"};
  
  textAlign(CENTER, CENTER);
  textFont(font1);  

  for(int i = 0; i < 1500; i += 100)
    text(labels[i/100], 
    rowMargin * 0.7, 
    colMargin + cellHeight / 2 + i / 100 * cellHeight);
  
  //Column Labels
  textAlign(RIGHT, CENTER);
  String[] yearL = {"2005", "2006", "2007", "2008", "2009", "2010", "2011",
                    "2012", "2013"};
                    
  for(int i = 1; i <= numColumns; i++)
  {
    if(i % 12 == 0 ) //12 months
    {
      text(yearL[i / 12 - 1],
      rowMargin - (cellWidth / 2) + (i * cellWidth) - (cellWidth * 3.5),
      height - 1.8 * colMargin);
    }
  }

  //Title
  textAlign(CENTER, CENTER);
  textFont(font2);
  text("Harry Potter Book and Movie Checkouts", width / 2, height * 0.14);
  
  //Outline Border for Cells
  stroke(outlineBorder[colorTheme]);
  strokeWeight(0.5);
  noFill();
  rect(rowMargin, colMargin, cellWidth * numColumns, cellHeight * numRows);
  
  //Color Bar
  if(colorTheme < 5)
  {
    noStroke();
    for(int i = 0; i < barDiv[colorTheme]; i+=1)
    {
      colorMode(colorMode[colorTheme]);
      colorBarFill(i);
      rect(barPosX + (i * (barLength / barDiv[colorTheme])), barPosY, 
           barLength / barDiv[colorTheme], barHeight);
    }
  }
  else //Fill the two color bars
  {
    noStroke();
    for(int i = 0; i < barDiv[colorTheme]; i+=1)
    {
      colorMode(colorMode[colorTheme]);
      
      barColor = 0;
      colorBarFill(i);      
      rect(barPosX + (i * (barLength / barDiv[colorTheme])), barPosY, 
           barLength / barDiv[colorTheme], barHeight / 2);
           
      barColor = 1;
      colorBarFill(i);
      rect(barPosX + (i * (barLength / barDiv[colorTheme])), barPosY + 30, 
           barLength / barDiv[colorTheme], barHeight / 2);
    }
  }
  
  //Color Bar Outline
  if(colorTheme < 5)
  {
    noFill();
    colorMode(RGB);
    stroke(colorBarOutline[colorTheme]);
    strokeWeight(0.4);
    rect(barPosX, barPosY, barLength, barHeight);
  }
  else //This is for the double bar
  {
    noFill();
    colorMode(RGB);
    stroke(colorBarOutline[colorTheme]);
    strokeWeight(0.4);
    rect(barPosX, barPosY, barLength, barHeight / 2);
    rect(barPosX, barPosY + 30, barLength, barHeight / 2);
  }
  
  //Color Bar Label
  if(colorTheme < 5)
  {
    fill(colorLabel[colorTheme]);
    textAlign(CENTER, CENTER);
    textFont(font1);
    text("Least checkouts", barPosX, barPosY + 45);
    text("Most checkouts", barPosX + barLength, barPosY + 45);
  }
  else //This is for the double bar
  {
    fill(colorLabel[colorTheme]);
    textAlign(CENTER, CENTER);
    textFont(font1);
    text("Least checkouts", barPosX + 45, barPosY + 65);
    text("Most checkouts", barPosX + barLength - 40, barPosY + 65);
    
    text("Books", barPosX - 25, barPosY + 5);
    text("Films", barPosX - 25, barPosY + 35);
  }
}
